-- Frame   Go to/Play Number

-- nav
-- drag to a sprite or a frame
-- goto a frame on author selected event
-- also functions through lingo by handling message 'initGotoFrame', 
-- for example if this behavior was assigned to sprite 5, use
-- sendsprite 5, #initGotoFrame


property  whichFrame, whichEvent, playmode

on initGotoFrame me
  init me
end

on mouseUp me
  if whichEvent = #mouseup    then init me
end

on prepareFrame me
  if whichEvent = #prepareframe then init me
end

on exitFrame me
  if whichEvent = #exitframe  then init me
end

on init me
  if the playmode of me = #"Play and Return" then
    play frame (the whichframe of me)
  else   
    go frame (the whichframe of me)   
  end if
end

---

on getPropertyDescriptionList  
  set p_list = [ ¬
    #WhichFrame: [ #comment:   "Destination Frame:", ¬
                    #format:   #integer, ¬
                   #default:    1 ], ¬
    #WhichEvent: [ #comment:   "Initializing Event:", ¬
                    #format:   #symbol, ¬
                     #range: [ #MouseUp, #PrepareFrame, #ExitFrame, #InitGotoFrame], ¬
                   #default:   #MouseUp ], ¬
      #playMode: [ #comment:   "Play Mode:", ¬
                    #format:   #symbol, ¬
                     #range: [ #"Go to", #"Play and Return" ], ¬
                   #default:   #"Go to" ] ¬
  ]
  return p_list
  
end

on getBehaviorDescription
  return ¬
"Moves the Playback Head to the designated frame when the specified event occurs.  Drag to a sprite or frame in the script channel." && RETURN & ¬
"PARAMETERS:" && RETURN & ¬
"• Destination Frame - Enter the number of the desired frame."  && RETURN & ¬
"• Initializing Event - Choose the event that triggers the behavior." && RETURN & ¬
"• Play Mode - Choose Play and Return to make the Playback Head return to the current location when the Play Done behavior is encountered. Choose Go To to make the Playback Head continue from the specified frame until explicitly sent to a new location."
end

