-- Marker    Go to      Next 

-- Nav
-- drag to a sprite 
-- goes to next marker on author selected event
-- also functions through lingo by handling message 'initGotoNextMarker', 
-- for example if this behavior was assigned to sprite 5, use
-- sendsprite 5, #initGotoNextMarker

property whichEvent

on initGotoNextMarker me
  init me
end

on mouseUp me
  if whichEvent = #mouseup    then init me
end

on prepareFrame me
  if whichEvent = #prepareframe then init me
end

on exitFrame me
  if whichEvent = #exitframe  then init me
end

on init me
  go to marker (1)
end



---

on getPropertyDescriptionList
  
  set p_list = [ ¬
    #WhichEvent: [ #comment:  "Initializing Event:", ¬
                    #format:   #symbol, ¬
                     #range: [ #MouseUp, #PrepareFrame, #ExitFrame, #InitGotoNextMarker], ¬
                   #default:   #MouseUp ] ¬
                 ]
  return p_list
  
end

on getBehaviorDescription
  return ¬
"Moves the Playback Head to the next marker when the specified event occurs.  Drag to a sprite or a frame in the script channel." && RETURN & ¬
"PARAMETERS:" && RETURN & ¬
"• Initializing Event - Specify the event that triggers the behavior."
  
end

