-- Web       Go to       Page

-- when called froma shockwave movie, replaces the shocked page.  When called from authoring
-- or projector, launches a browser and displays the page.
--
-- also functions through lingo by handling message 'initGotoNetPage', 
-- for example if this behavior was assigned to sprite 5, use
-- sendsprite 5, #initGotoNetPage


property whichEvent, whichURL

on initGotoNetPage me
  init me
end

on mouseUp me
  if whichEvent = #mouseup    then init me
end

on prepareFrame me
  if whichEvent = #prepareframe then init me
end

on exitFrame me
  if whichEvent = #exitframe  then init me
end

on init me
  gotoNetPage the whichURL of me
end

---

on getPropertyDescriptionList  
  set p_list = [ ¬
      #WhichURL: [ #comment:   "Destination URL:", ¬
                    #format:   #string, ¬
                   #default:   "http://www.macromedia.com                  " ],¬
    #WhichEvent: [ #comment:   "Initializing Event:", ¬
                    #format:   #symbol, ¬
                     #range: [ #MouseUp, #PrepareFrame, #ExitFrame, #InitGotoNetPage], ¬
                   #default:   #MouseUp ] ¬
                 ]
  return p_list  
end

on getBehaviorDescription
  return ¬
"Loads the designated HTML Page when the specified event occurs.  When called from a Shockwave movie, this behavior replaces the current page displayed in the web browser.  When called from a projector or in authoring mode, it opens a browser to display the requested page." & RETURN & ¬
"PARAMETERS:" & RETURN & ¬
"• Destination URL - Enter the complete URL of the destination page. Include http://."  & RETURN & ¬
"• Initializing Event - Specify the event that triggers the behavior."  
  
end

