-- Play Done (Return from Play)


--  nav
--  playdone, returns playhead to calling movie or frame or marker where play was called.
-- also functions through lingo by handling message 'initPlayDone', 
-- for example if this behavior was assigned to sprite 5, use
-- sendsprite 5, #initPlayDone

property whichEvent

on initPlayDone me
  init me
end

on mouseUp me
  if whichEvent = #mouseup    then init me
end

on prepareFrame me
  if whichEvent = #prepareframe then init me
end

on exitFrame me
  if whichEvent = #exitframe  then init me
end

on init me 
  playdone
end



---

on getPropertyDescriptionList
  
  set p_list = [ ¬
    #WhichEvent: [ #comment:  "Initializing Event:", ¬
                    #format:   #symbol, ¬
                     #range: [ #MouseUp, #PrepareFrame, #ExitFrame, #InitPlayDone], ¬
                   #default:   #MouseUp ] ¬
                 ]
  return p_list  
  
end

on getBehaviorDescription
  return ¬
"Returns the Playback Head to the frame where a navigation behavior with the Play Mode parameter set to Play and Return was encountered.  If the current movie was opened with the Play Movie behavior, the original movie reappears." && RETURN & ¬
"PARAMETERS:" && RETURN & ¬
"• Initializing Event - Specify the event that triggers the behavior."
  
end

