--  Sound Play File


-- also functions through lingo by handling message 'initPlayFile', 
-- for example if this behavior was assigned to sprite 5, use
-- sendsprite 5, #initPlayFile

-- Media
property WhichEvent, WhichSound, WhichChannel, StartImmediately
property tester

on initPlayFile me
  init me
end

on mouseUp me
  if whichEvent = #mouseup    then init me
end

on mouseDown me
  if whichEvent = #mousedown  then init me
end

on prepareFrame me
  if whichEvent = #prepareframe then init me
end

on enterFrame me
  if whichEvent = #enterframe then init me
end

on exitFrame me
  if whichEvent = #exitframe  then init me
end

on init me
  sound playFile the whichChannel of me, the soundFile of me
end

---

on getPropertyDescriptionList
  
  set p_list = [ ¬
     #soundFile: [ #comment:   "Sound File:", ¬
                    #format:   #string, ¬
                   #default:   "" ], ¬
  #whichChannel: [ #comment:   "Channel:", ¬
                    #format:   #integer, ¬
                   #default:    1 ], ¬
    #whichEvent: [ #comment:   "Initializing Event:", ¬
                    #format:   #symbol, ¬
                     #range: [ #MouseUp, #MouseDown, #PrepareFrame,#EnterFrame, #ExitFrame, #InitPlayFile], ¬
                   #default:   #MouseUp ]¬
                 ]
  return p_list  
end

on BeginSprite me
  -- check for relative pathnames and convert them to absolutes
  -- to support organizing files in subdirectories
  set f = the soundFile of me
  if (( f contains "\" ) OR ( f contains "/" )) then  -- trying to specify a path
    if NOT ( f contains ":" ) then                    -- leave absolute paths alone
      set the soundFile of me = the moviePath & the soundFile of me
    end if
  end if
end

on getBehaviorDescription
  return ¬
"Plays the designated external sound file ( AIFF or WAVE format ) when the specified event occurs." & RETURN & ¬
"PARAMETERS:" & RETURN & ¬
"• Sound - Enter the file name of the external sound file to be played. If the file is not in the same folder as the movie, enter the relative pathname. To play a sound from the internet, enter a URL."  & RETURN & ¬
"• Channel - Enter the number of the sound channel to be used for playback."  & RETURN & ¬
"• Initializing Event - Specify the event that triggers the behavior."
end

