-- Net Hold Until Frame Ready


property useframes, frameA, frameB, markA, markB, singleframe


on beginsprite me
  set  singleframe = FALSE
  if useframes = #UseFrames then
    if frameB <= frameA then 
      set singleframe = TRUE
    end if
  else  -- useMarkers
    set frameA = marker (markA)
    set frameB = marker (markB)
    if frameB <= frameA then 
      set singleframe = TRUE
    end if
  end if
  
end

on prepareframe me
  if singleframe then
    if not frameReady (frameA) then 
      go the frame
    end if
  else -- not singleframe
    if not frameReady (frameA, frameB) then 
      go the frame
    end if
  end if
end


on getPropertyDescriptionList
  
  set p_list = [ ¬
     #useframes: [ #comment:   "Syntax:", ¬
                    #format:   #symbol, ¬
                     #range:  [#UseFrames, #UseMarkers],¬
                   #default:    #UseFrames ], ¬
        #frameA: [ #comment:   "Begin Frame:", ¬
                    #format:   #integer, ¬
                   #default:    1 ] ,¬
        #frameB: [ #comment:   "End Frame:", ¬
                    #format:   #integer, ¬
                   #default:    1 ] ,¬
         #markA: [ #comment:   "Begin Marker:", ¬
                    #format:   #marker, ¬
                   #default:    1 ] ,¬
         #markB: [ #comment:   "End Marker:", ¬
                    #format:   #marker, ¬
                   #default:    1 ] ¬
  ]
  return p_list
end

on getBehaviorDescription 
  return ¬
"Loops on the current frame until media in the specified frame range is loaded.  Define a range with frame numbers or marker names." & RETURN & ¬
"PARAMETERS:" & RETURN & ¬
"• Syntax - Choose UseFrames or UseMarkers." & RETURN & ¬
"• Begin Frame - Enter the number of the first frame in the range."  & RETURN & ¬
"• End Frame - Enter the number of the last frame in the range."  & RETURN & ¬
"• Begin Marker - Choose the first marker in the range."  & RETURN & ¬
"• End Marker - Choose the last marker in the range."
  
  
end

