-- Setting  Radio   Group Item

-- control, drag this onto a system radio button to add it to a group
-- check if it works for push button, check box, radio button

-- will receive setRadioValue, getRadioValue, radio_button_selected, groupname 
-- which_radio_button_selected returns the text of the selected item of the group

property  GroupName, GroupSetting
property  selectedButton, default

on mouseUp me
  setGroupValue me
end

on beginSprite me
  if default = TRUE then
    SendAllSprites #clearGroup, groupname
    set selectedButton = the spritenum of me
    setgroupValue me
  else
    SendAllSprites #clearGroup, groupname
  end if
end

on getRadioValue me, GName
  if GName = the GroupName of me then
    dontPassEvent
    return the text of member (the member of sprite (the selectedButton of me))
  end if
end

on setRadioValue me, GName, selected_sprite_num
  set MNum  = the member of sprite (the spritenum of me)
  
  if GName = the GroupName of me then   
    if the spritenum of me <> selected_sprite_num then
      radioHilite me, FALSE
    end if
    set the selectedButton of me to selected_sprite_num 
  end if
end


on setGroupValue me  
  SendAllSprites #SetRadioValue, the GroupName of me, the spritenum of me
  radioHilite me, TRUE
end

on clearGroup me, gname
  if  GName = the GroupName of me then
    if default = FALSE then
      radioHilite me, FALSE
    else
      radioHilite me, TRUE
    end if  
  end if
end


---

on getPropertyDescriptionList
  
  return [¬
  #GroupName: [ #default: #group1, #format:#symbol, #comment:"Group Name"], ¬
  #default  : [ #default: 0, #format:#boolean, #comment:"Initially Selected?"] ¬
  ]
  
end

on getBehaviorDescription
  return ¬
"Includes the current sprite in a radio button group. Attach to toggle buttons controlled by the UI Toggle Button behavior, or radio buttons created with the Radio Button tool on the Tools palette. The GetRadioValue message returns the text of the selected button. "&RETURN&¬
"PARAMETERS:"&RETURN&¬
"• Group Name - Enter the name of the group to which this radio button belongs.  Only one member of the group can be selected at at time. Do not use spaces."&RETURN&¬
"• Initially Selected - Turn this option on to make this radio button selected when the sprite first appears.  If more than one radio button has Initially Selected on, the highest numbered sprite is selected. "&RETURN&¬
"MESSAGES:" & RETURN & ¬
"• GetRadioValue group_name - Returns the text of the named radio group's selected button." & RETURN & ¬
"• SetRadioValue group_name, sprite_number - Sets the named radio button group's setting to be the sprite."& RETURN & ¬
"• SetGroupValue - Sets the sprite to the group setting."
end



on getAssocMembers --added, fmk
  set myPropList = [  ]
  
  return myPropList
end getAssocMembers



on RadioHilite me, val
  -- assumes if the sprite is not of type button, that it is a toggle button.  If it's neither no adverse effect.
  if ( the type of member ( the memberNum of sprite ( the spriteNum of me)) = #button)  then
    set the hilite of member (the member of sprite (the spritenum of me)) to val
  else
    sendSprite (the spritenum of me, #setToggleValue, val )
  end if
end
