-- Video   Controller   Commands

-- a control

property videoSprite    -- the sprite number that is getting controlled
property videoCommand   -- the command to be issued

on InitVidControl me
  case ( the VideoCommand of me ) of:
    #Play:
      set the movieRate of sprite the VideoSprite of me = 1
    #Pause:
      set the movieRate of sprite the VideoSprite of me = 0
    #Stop:
      set the movieRate of sprite the VideoSprite of me = 0
      set the movietime of sprite the VideoSprite of me = 0
    #Rewind:
      set the movietime of sprite the VideoSprite of me = 0
  end case
end


on mouseUp me
  initVidControl me
end

---

on getPropertyDescriptionList
  set p_list = [ ¬
  #videoCommand: [ #comment:   "Command:", ¬
                    #format:   #symbol, ¬
                     #range: [ #Play, #Pause, #Stop, #Rewind ], ¬
                   #default:   #Play ], ¬
   #videoSprite: [ #comment:   "Video Sprite Channel:", ¬
                    #format:   #integer, ¬
                   #default:    1 ] ¬
                 ]
  return p_list
end

on getBehaviorDescription
  return ¬
"Provides Play, Pause, Stop, or Rewind controls for a digital video sprite." & RETURN & ¬
"PARAMETERS:" & RETURN & ¬
"• Command - Choose the video playback command to invoke ( Play, Pause, Stop, Rewind )." & RETURN & ¬
"• Sprite - Enter the number of sprite channel in which video is displayed." 
end

