-- Pointer Change


-- Changes the stage cursor for the movie, add to any sprite on stage.
-- handles ChangeCursor and RestoreCursor messages

property  pointerStyle,  CustomImage, CustomMask, currentPointer
property  Rpointerstyle, RCustomImage, RCustomMask

property useCustom, useCustomR -- boolean, tru if use custom cursor art for cursor and/or restored cursor

property changeBegin, changeEnd

on beginSprite me
  if changeBegin then
    changecursor me  
  end if
  
end

on EndSprite me  
  if changeEnd then
    restorecursor me  
  end if
end

on ChangeCursor me
  set currentPointer = translate_cursor( me, pointerStyle, customImage, customMask, useCustom )
  cursor( currentPointer )
end

on restoreCursor me
  set currentPointer = translate_cursor( me, RpointerStyle, RcustomImage, RcustomMask, useCustomR  )
  cursor( currentPointer )
end

on translate_cursor me, setting, image, mask, custom
  if custom then
    set val = [ member image, member mask ]
    return val
  end if
  return setting
end



---

on getPropertyDescriptionList
  
  set p_list = [ ¬
  #changeBegin: [ #comment:    "Change Pointer on BeginSprite:", ¬
                    #format:   #boolean, #default:false], ¬
  #changeEnd: [ #comment:      "Restore Pointer on EndSprite:", ¬
                    #format:   #boolean, #default:false], ¬
  #pointerStyle: [ #comment:   "Pointer Image:", ¬
                    #format:   #cursor, #default: 1], ¬
  #useCustom: [ #comment:      "Use Custom Pointer Image:", ¬
                    #format:   #boolean, #default:false], ¬
  #customImage: [ #comment:    "Custom Image:", ¬
                    #format:   #bitmap, ¬
                   #default:    member 1 ], ¬
    #customMask: [ #comment:   "Custom Mask:", ¬
                    #format:   #bitmap, ¬
                   #default:    member 1 ], ¬
  #RpointerStyle: [ #comment:  "Restored Pointer Image:", ¬
                    #format:   #cursor, #default:1], ¬
  #useCustomR: [ #comment:     "Restore Custom Pointer Image:", ¬
                    #format:   #boolean, #default:false], ¬
  #RcustomImage: [ #comment:   "Restored Custom Image:", ¬
                    #format:   #bitmap, ¬
                   #default:    member 1 ], ¬
    #RcustomMask: [ #comment:  "Restored Custom Mask:", ¬
                    #format:   #bitmap, ¬
                   #default:    member 1 ] ¬
  ]
  return p_list  
end

on getBehaviorDescription
  return ¬
"Changes the pointer image to one of the pointers included with Director, or to a  1-bit bitmapped castmember. Attach the behavior to a sprite or place it in the script channel." & RETURN & ¬
"PARAMETERS:" & RETURN & ¬
"• Change on BeginSprite - Turn this option on to change the pointer in the frame where the sprite begins."  & RETURN & ¬
"• Change on EndSprite - Turn this option on to restore the pointer in the frame after the sprite ends."  & RETURN & ¬
"• Pointer - Choose one of Director's included pointers."  & RETURN & ¬
"• Use Custom - Turn this option on to use a cast member for a pointer instead of one of Director's included pointers."  & RETURN & ¬
"• Custom Image  - ( optional ) Choose which cast member to use as a pointer image. This setting is ignored if Use Custom isn't on."  & RETURN & ¬
"• Custom Mask - ( optional ) Choose a cast member to use as a mask image." & RETURN & ¬
"• Restored Pointer - Choose one of Director's included pointers to be displayed when the sprite ends."  & RETURN & ¬
"• Restore Custom - Turn this option on to display a cast member when the sprite ends."  & RETURN & ¬
"• Restored Custom Image  - ( optional ) Choose a cast member to display as the pointer image when the sprite ends."  & RETURN & ¬
"• Restored Custom Mask - ( optional ) Choose a cast member to use as a mask image when the sprite ends.  " & RETURN & ¬
"MESSAGES:" & RETURN & ¬
"• ChangeCursor - Changes the pointer to the specified image."  & RETURN & ¬
"• RestoreCursor - Restores the original pointer image."
  
end
