-- Pointer Rollover and Mouse Down, Up



-- a control
-- Changes the cursor when the cursor rollsover the sprite
property outcurs, incurs, incursSet, customImage, customMask, customDownImage, customDownMask
property incursDownSet, oldcursor
property useCustom, useCustomDown

on translate_cursor me, setting, image, mask, custom
  if custom then
    set val = [ member image, member mask ]
    return val
  end if
  return setting
end


--- 


on beginSprite me
  set oldcursor = the cursor of sprite the spritenum of me
  set val =  translate_cursor( me, the incursSet of me, customImage, customMask, useCustom )
  set the cursor of sprite the spriteNum of me = val
  
end

on endsprite me
  set the cursor of sprite the spriteNum of me = oldcursor
end

on mousedown me
  set val =  translate_cursor( me, the incursDownSet of me, customDownImage, customDownMask, useCustomDown )
  set the cursor of sprite the spriteNum of me = val
end  
on mouseupOutside me
  set val =  translate_cursor( me, the incursSet of me, customImage, customMask, useCustom )
  set the cursor of sprite the spriteNum of me = val
end
on mouseup me
  set val =  translate_cursor( me, the incursSet of me, customImage, customMask, useCustom )
  set the cursor of sprite the spriteNum of me = val
end

on getPropertyDescriptionList
  
  set p_list = [ ¬
     #incursSet: [ #comment:   "Rollover Pointer Image:", ¬
                    #format:   #cursor, ¬
                    #default:   1 ], ¬
       #useCustom: [ #comment: "Use Custom Pointer:", ¬
                    #format:   #boolean, ¬
                   #default:    FALSE ], ¬
  #customImage: [ #comment:   "Custom Image:", ¬
                    #format:   #bitmap, ¬
                   #default:    member 1 ], ¬
    #customMask: [ #comment:   "Custom Mask:", ¬
                    #format:   #bitmap, ¬
                   #default:    member 1 ], ¬
     #incursDownSet: [ #comment:   "Mouse Down Pointer Image:", ¬
                    #format:   #cursor, ¬
                   #default:   1], ¬
       #useCustomDown: [ #comment: "Use Custom Pointer When Mouse Down:", ¬
                    #format:   #boolean, ¬
                   #default:    FALSE ], ¬
  #customDownImage: [ #comment:   "Custom Down Image:", ¬
                    #format:   #bitmap, ¬
                   #default:    member 1 ], ¬
    #customDownMask: [ #comment:   "Custom Down Mask:", ¬
                    #format:   #bitmap, ¬
                   #default:    member 1 ] ¬
  ]
  return p_list 
  
end


on getBehaviorDescription
  return ¬
"Makes the pointer image change when the pointer is over the current sprite, also defines a different pointer image to display when the sprite is clicked. Choose any of the pointers included with Director or a 1-bit bitmapped cast member." & RETURN & ¬
"PARAMETERS:" & RETURN & ¬
"• Rollover Pointer Image - Choose the pointer image to appear when the pointer rolls over the sprite. Select one of Director's included pointers."  & RETURN & ¬
"• Use Custom Pointer - Turn this option on to specify a cast member instead of an included pointer." & RETURN & ¬
"• Custom Image  - ( optional ) Choose a cast member to use as the pointer image.  This choice is ignored unless Use Custom Pointer is on."  & RETURN & ¬
"• Custom Mask - ( optional ) Choose a cast member to use as a mask image.  "&RETURN&¬
"• Mouse Down Pointer Image - Choose one of Director's included pointers to be displayed when the mouse is down."  & RETURN & ¬
"• Use Custom Pointer When Mouse Down - Turn this option on to specify a cast member as the mouse down pointer instead of one of Director's included pointers."  & RETURN & ¬
"• Custom Down Image  - ( optional ) Choose a cast member to use as a pointer image when the mouse is down.  This setting is ignored unless Use Custom Pointer When Mouse Down is on."  & RETURN & ¬
"• Custom Down Mask - ( optional ) Choose a cast member to use as a mask image when mouse is down."
  
end

